/* ImageManager.c generated by valac 0.56.3, the Vala compiler
 * generated from ImageManager.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <libxml/tree.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_IMAGE_MANAGER (image_manager_get_type ())
#define IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_MANAGER, ImageManager))
#define IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_MANAGER, ImageManagerClass))
#define IS_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_MANAGER))
#define IS_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_MANAGER))
#define IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_MANAGER, ImageManagerClass))

typedef struct _ImageManager ImageManager;
typedef struct _ImageManagerClass ImageManagerClass;
typedef struct _ImageManagerPrivate ImageManagerPrivate;

#define IMAGE_MANAGER_TYPE_IMAGE_ITEM (image_manager_image_item_get_type ())
#define IMAGE_MANAGER_IMAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItem))
#define IMAGE_MANAGER_IMAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItemClass))
#define IMAGE_MANAGER_IS_IMAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMAGE_MANAGER_TYPE_IMAGE_ITEM))
#define IMAGE_MANAGER_IS_IMAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMAGE_MANAGER_TYPE_IMAGE_ITEM))
#define IMAGE_MANAGER_IMAGE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItemClass))

typedef struct _ImageManagerImageItem ImageManagerImageItem;
typedef struct _ImageManagerImageItemClass ImageManagerImageItemClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _image_manager_image_item_unref0(var) ((var == NULL) ? NULL : (var = (image_manager_image_item_unref (var), NULL)))
typedef struct _ImageManagerImageItemPrivate ImageManagerImageItemPrivate;
typedef struct _ImageManagerParamSpecImageItem ImageManagerParamSpecImageItem;
typedef struct _ParamSpecImageManager ParamSpecImageManager;

struct _ImageManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImageManagerPrivate * priv;
};

struct _ImageManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ImageManager *self);
};

struct _ImageManagerPrivate {
	GArray* _images;
	gboolean _available;
	GeeHashMap* _id_map;
};

struct _ImageManagerImageItem {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImageManagerImageItemPrivate * priv;
};

struct _ImageManagerImageItemClass {
	GTypeClass parent_class;
	void (*finalize) (ImageManagerImageItem *self);
};

struct _ImageManagerImageItemPrivate {
	gint _id;
	gchar* _uri;
	gchar* _ext;
	gboolean _valid;
};

struct _ImageManagerParamSpecImageItem {
	GParamSpec parent_instance;
};

struct _ParamSpecImageManager {
	GParamSpec parent_instance;
};

static gint ImageManager_private_offset;
static gpointer image_manager_parent_class = NULL;
static gint ImageManagerImageItem_private_offset;
static gpointer image_manager_image_item_parent_class = NULL;
VALA_EXTERN GSettings* minder_settings;

VALA_EXTERN gpointer image_manager_ref (gpointer instance);
VALA_EXTERN void image_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_image_manager (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_image_manager (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_image_manager (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_image_manager (const GValue* value);
VALA_EXTERN GType image_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImageManager, image_manager_unref)
static gpointer image_manager_image_item_ref (gpointer instance);
static void image_manager_image_item_unref (gpointer instance);
static GParamSpec* image_manager_param_spec_image_item (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags) G_GNUC_UNUSED ;
static void image_manager_value_set_image_item (GValue* value,
                                         gpointer v_object) G_GNUC_UNUSED ;
static void image_manager_value_take_image_item (GValue* value,
                                          gpointer v_object) G_GNUC_UNUSED ;
static gpointer image_manager_value_get_image_item (const GValue* value) G_GNUC_UNUSED ;
static GType image_manager_image_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImageManagerImageItem, image_manager_image_item_unref)
static gchar* image_manager_get_storage_path (void);
VALA_EXTERN ImageManager* image_manager_new (void);
VALA_EXTERN ImageManager* image_manager_construct (GType object_type);
static void _image_manager_image_item_unref0_ (gpointer var);
static void _vala_ImageManagerImageItem_free_function_content_of (gpointer data);
VALA_EXTERN void image_manager_load (ImageManager* self,
                         xmlNode* n);
static ImageManagerImageItem* image_manager_image_item_new_from_xml (xmlNode* n);
static ImageManagerImageItem* image_manager_image_item_construct_from_xml (GType object_type,
                                                                    xmlNode* n);
static gint image_manager_image_item_get_id (ImageManagerImageItem* self);
VALA_EXTERN void image_manager_save (ImageManager* self,
                         xmlNode* n);
static gboolean image_manager_image_item_get_valid (ImageManagerImageItem* self);
static void image_manager_image_item_save (ImageManagerImageItem* self,
                                    xmlNode* parent);
static ImageManagerImageItem* image_manager_find_match (ImageManager* self,
                                                 gint id);
static ImageManagerImageItem* image_manager_find_uri_match (ImageManager* self,
                                                     const gchar* uri);
static const gchar* image_manager_image_item_get_uri (ImageManagerImageItem* self);
VALA_EXTERN gint image_manager_add_image (ImageManager* self,
                              const gchar* uri,
                              gint* orig_id);
static ImageManagerImageItem* image_manager_image_item_new (const gchar* uri);
static ImageManagerImageItem* image_manager_image_item_construct (GType object_type,
                                                           const gchar* uri);
static gboolean image_manager_image_item_copy_file (ImageManagerImageItem* self);
static gboolean image_manager_image_item_exists (ImageManagerImageItem* self);
VALA_EXTERN gint image_manager_add_pixbuf (ImageManager* self,
                               GdkPixbuf* buf,
                               gint* orig_id);
static gchar* image_manager_image_item_get_path (ImageManagerImageItem* self);
VALA_EXTERN gchar* image_manager_get_file (ImageManager* self,
                               gint id);
VALA_EXTERN gchar* image_manager_get_mime_type (ImageManager* self,
                                    gint id);
static gchar* image_manager_image_item_get_extension (ImageManagerImageItem* self);
VALA_EXTERN GArray* image_manager_get_ids (ImageManager* self);
VALA_EXTERN gchar* image_manager_get_uri (ImageManager* self,
                              gint id);
VALA_EXTERN void image_manager_set_valid (ImageManager* self,
                              gint id,
                              gboolean value);
static void image_manager_image_item_set_valid (ImageManagerImageItem* self,
                                         gboolean value);
VALA_EXTERN void image_manager_cleanup (ImageManager* self);
static void image_manager_image_item_cleanup (ImageManagerImageItem* self);
VALA_EXTERN gint image_manager_get_id (ImageManager* self,
                           gint id);
VALA_EXTERN gint image_manager_choose_image (ImageManager* self,
                                 GtkWindow* parent);
VALA_EXTERN void utils_set_chooser_folder (GtkFileChooser* chooser);
VALA_EXTERN void utils_store_chooser_folder (const gchar* file);
static void image_manager_image_item_set_id (ImageManagerImageItem* self,
                                      gint value);
static void image_manager_image_item_set_uri (ImageManagerImageItem* self,
                                       const gchar* value);
static void image_manager_image_item_set_ext (ImageManagerImageItem* self,
                                       const gchar* value);
static const gchar* image_manager_image_item_get_ext (ImageManagerImageItem* self);
static void image_manager_image_item_finalize (ImageManagerImageItem * obj);
static GType image_manager_image_item_get_type_once (void);
static void image_manager_finalize (ImageManager * obj);
static GType image_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
image_manager_get_instance_private (ImageManager* self)
{
	return G_STRUCT_MEMBER_P (self, ImageManager_private_offset);
}

static gchar*
image_manager_get_storage_path (void)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 30 "../src/ImageManager.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 30 "../src/ImageManager.vala"
	_tmp1_ = g_build_filename (_tmp0_, "minder", "images", NULL);
#line 30 "../src/ImageManager.vala"
	result = _tmp1_;
#line 30 "../src/ImageManager.vala"
	return result;
#line 249 "ImageManager.c"
}

static void
_image_manager_image_item_unref0_ (gpointer var)
{
#line 135 "../src/ImageManager.vala"
	(var == NULL) ? NULL : (var = (image_manager_image_item_unref (var), NULL));
#line 257 "ImageManager.c"
}

static void
_vala_ImageManagerImageItem_free_function_content_of (gpointer data)
{
	ImageManagerImageItem* self;
#line 135 "../src/ImageManager.vala"
	self = *((ImageManagerImageItem**) data);
#line 135 "../src/ImageManager.vala"
	_image_manager_image_item_unref0_ (self);
#line 268 "ImageManager.c"
}

ImageManager*
image_manager_construct (GType object_type)
{
	ImageManager* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	GArray* _tmp3_;
	GeeHashMap* _tmp4_;
#line 127 "../src/ImageManager.vala"
	self = (ImageManager*) g_type_create_instance (object_type);
#line 130 "../src/ImageManager.vala"
	_tmp0_ = image_manager_get_storage_path ();
#line 130 "../src/ImageManager.vala"
	_tmp1_ = _tmp0_;
#line 130 "../src/ImageManager.vala"
	_tmp2_ = g_mkdir_with_parents (_tmp1_, 0775) == 0;
#line 130 "../src/ImageManager.vala"
	_g_free0 (_tmp1_);
#line 130 "../src/ImageManager.vala"
	if (_tmp2_) {
#line 131 "../src/ImageManager.vala"
		self->priv->_available = TRUE;
#line 294 "ImageManager.c"
	}
#line 135 "../src/ImageManager.vala"
	_tmp3_ = g_array_new (TRUE, TRUE, sizeof (ImageManagerImageItem*));
#line 135 "../src/ImageManager.vala"
	g_array_set_clear_func (_tmp3_, (GDestroyNotify) _vala_ImageManagerImageItem_free_function_content_of);
#line 135 "../src/ImageManager.vala"
	_g_array_unref0 (self->priv->_images);
#line 135 "../src/ImageManager.vala"
	self->priv->_images = _tmp3_;
#line 136 "../src/ImageManager.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 136 "../src/ImageManager.vala"
	_g_object_unref0 (self->priv->_id_map);
#line 136 "../src/ImageManager.vala"
	self->priv->_id_map = _tmp4_;
#line 127 "../src/ImageManager.vala"
	return self;
#line 312 "ImageManager.c"
}

ImageManager*
image_manager_new (void)
{
#line 127 "../src/ImageManager.vala"
	return image_manager_construct (TYPE_IMAGE_MANAGER);
#line 320 "ImageManager.c"
}

static gpointer
_image_manager_image_item_ref0 (gpointer self)
{
#line 147 "../src/ImageManager.vala"
	return self ? image_manager_image_item_ref (self) : NULL;
#line 328 "ImageManager.c"
}

void
image_manager_load (ImageManager* self,
                    xmlNode* n)
{
#line 141 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 337 "ImageManager.c"
	{
		xmlNode* it = NULL;
		xmlNode* _tmp0_;
#line 142 "../src/ImageManager.vala"
		_tmp0_ = n->children;
#line 142 "../src/ImageManager.vala"
		it = _tmp0_;
#line 345 "ImageManager.c"
		{
			gboolean _tmp1_ = FALSE;
#line 142 "../src/ImageManager.vala"
			_tmp1_ = TRUE;
#line 142 "../src/ImageManager.vala"
			while (TRUE) {
#line 352 "ImageManager.c"
				xmlNode* _tmp4_;
				xmlNode* _tmp5_;
#line 142 "../src/ImageManager.vala"
				if (!_tmp1_) {
#line 357 "ImageManager.c"
					xmlNode* _tmp2_;
					xmlNode* _tmp3_;
#line 142 "../src/ImageManager.vala"
					_tmp2_ = it;
#line 142 "../src/ImageManager.vala"
					_tmp3_ = _tmp2_->next;
#line 142 "../src/ImageManager.vala"
					it = _tmp3_;
#line 366 "ImageManager.c"
				}
#line 142 "../src/ImageManager.vala"
				_tmp1_ = FALSE;
#line 142 "../src/ImageManager.vala"
				_tmp4_ = it;
#line 142 "../src/ImageManager.vala"
				if (!(_tmp4_ != NULL)) {
#line 142 "../src/ImageManager.vala"
					break;
#line 376 "ImageManager.c"
				}
#line 143 "../src/ImageManager.vala"
				_tmp5_ = it;
#line 143 "../src/ImageManager.vala"
				if (_tmp5_->type == XML_ELEMENT_NODE) {
#line 382 "ImageManager.c"
					xmlNode* _tmp6_;
					const gchar* _tmp7_;
#line 144 "../src/ImageManager.vala"
					_tmp6_ = it;
#line 144 "../src/ImageManager.vala"
					_tmp7_ = _tmp6_->name;
#line 144 "../src/ImageManager.vala"
					if (g_strcmp0 (_tmp7_, "image") == 0) {
#line 391 "ImageManager.c"
						ImageManagerImageItem* ii = NULL;
						xmlNode* _tmp8_;
						ImageManagerImageItem* _tmp9_;
						GeeHashMap* _tmp10_;
						ImageManagerImageItem* _tmp11_;
						gint _tmp12_;
						gint _tmp13_;
#line 145 "../src/ImageManager.vala"
						_tmp8_ = it;
#line 145 "../src/ImageManager.vala"
						_tmp9_ = image_manager_image_item_new_from_xml (_tmp8_);
#line 145 "../src/ImageManager.vala"
						ii = _tmp9_;
#line 146 "../src/ImageManager.vala"
						_tmp10_ = self->priv->_id_map;
#line 146 "../src/ImageManager.vala"
						_tmp11_ = ii;
#line 146 "../src/ImageManager.vala"
						_tmp12_ = image_manager_image_item_get_id (_tmp11_);
#line 146 "../src/ImageManager.vala"
						_tmp13_ = _tmp12_;
#line 146 "../src/ImageManager.vala"
						if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) _tmp13_))) {
#line 415 "ImageManager.c"
							GArray* _tmp14_;
							ImageManagerImageItem* _tmp15_;
							ImageManagerImageItem* _tmp16_;
#line 147 "../src/ImageManager.vala"
							_tmp14_ = self->priv->_images;
#line 147 "../src/ImageManager.vala"
							_tmp15_ = ii;
#line 147 "../src/ImageManager.vala"
							_tmp16_ = _image_manager_image_item_ref0 (_tmp15_);
#line 147 "../src/ImageManager.vala"
							g_array_append_val (_tmp14_, _tmp16_);
#line 427 "ImageManager.c"
						}
#line 144 "../src/ImageManager.vala"
						_image_manager_image_item_unref0 (ii);
#line 431 "ImageManager.c"
					}
				}
			}
		}
	}
}

void
image_manager_save (ImageManager* self,
                    xmlNode* n)
{
#line 155 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 445 "ImageManager.c"
	{
		gint i = 0;
#line 156 "../src/ImageManager.vala"
		i = 0;
#line 450 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 156 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 156 "../src/ImageManager.vala"
			while (TRUE) {
#line 457 "ImageManager.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				ImageManagerImageItem* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
#line 156 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 465 "ImageManager.c"
					gint _tmp1_;
#line 156 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 156 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 471 "ImageManager.c"
				}
#line 156 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 156 "../src/ImageManager.vala"
				_tmp2_ = self->priv->_images;
#line 156 "../src/ImageManager.vala"
				if (!(((guint) i) < _tmp2_->len)) {
#line 156 "../src/ImageManager.vala"
					break;
#line 481 "ImageManager.c"
				}
#line 157 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 157 "../src/ImageManager.vala"
				_tmp4_ = g_array_index (_tmp3_, ImageManagerImageItem*, (guint) i);
#line 157 "../src/ImageManager.vala"
				_tmp5_ = image_manager_image_item_get_valid (_tmp4_);
#line 157 "../src/ImageManager.vala"
				_tmp6_ = _tmp5_;
#line 157 "../src/ImageManager.vala"
				if (_tmp6_) {
#line 493 "ImageManager.c"
					GArray* _tmp7_;
					ImageManagerImageItem* _tmp8_;
#line 158 "../src/ImageManager.vala"
					_tmp7_ = self->priv->_images;
#line 158 "../src/ImageManager.vala"
					_tmp8_ = g_array_index (_tmp7_, ImageManagerImageItem*, (guint) i);
#line 158 "../src/ImageManager.vala"
					image_manager_image_item_save (_tmp8_, n);
#line 502 "ImageManager.c"
				}
			}
		}
	}
}

static ImageManagerImageItem*
image_manager_find_match (ImageManager* self,
                          gint id)
{
	ImageManagerImageItem* result;
#line 168 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 516 "ImageManager.c"
	{
		gint i = 0;
#line 169 "../src/ImageManager.vala"
		i = 0;
#line 521 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 169 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 169 "../src/ImageManager.vala"
			while (TRUE) {
#line 528 "ImageManager.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				ImageManagerImageItem* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 169 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 536 "ImageManager.c"
					gint _tmp1_;
#line 169 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 169 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 542 "ImageManager.c"
				}
#line 169 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 169 "../src/ImageManager.vala"
				_tmp2_ = self->priv->_images;
#line 169 "../src/ImageManager.vala"
				if (!(((guint) i) < _tmp2_->len)) {
#line 169 "../src/ImageManager.vala"
					break;
#line 552 "ImageManager.c"
				}
#line 170 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 170 "../src/ImageManager.vala"
				_tmp4_ = g_array_index (_tmp3_, ImageManagerImageItem*, (guint) i);
#line 170 "../src/ImageManager.vala"
				_tmp5_ = image_manager_image_item_get_id (_tmp4_);
#line 170 "../src/ImageManager.vala"
				_tmp6_ = _tmp5_;
#line 170 "../src/ImageManager.vala"
				if (_tmp6_ == id) {
#line 564 "ImageManager.c"
					GArray* _tmp7_;
					ImageManagerImageItem* _tmp8_;
					ImageManagerImageItem* _tmp9_;
#line 171 "../src/ImageManager.vala"
					_tmp7_ = self->priv->_images;
#line 171 "../src/ImageManager.vala"
					_tmp8_ = g_array_index (_tmp7_, ImageManagerImageItem*, (guint) i);
#line 171 "../src/ImageManager.vala"
					_tmp9_ = _image_manager_image_item_ref0 (_tmp8_);
#line 171 "../src/ImageManager.vala"
					result = _tmp9_;
#line 171 "../src/ImageManager.vala"
					return result;
#line 578 "ImageManager.c"
				}
			}
		}
	}
#line 174 "../src/ImageManager.vala"
	result = NULL;
#line 174 "../src/ImageManager.vala"
	return result;
#line 587 "ImageManager.c"
}

static ImageManagerImageItem*
image_manager_find_uri_match (ImageManager* self,
                              const gchar* uri)
{
	ImageManagerImageItem* result;
#line 181 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 181 "../src/ImageManager.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 599 "ImageManager.c"
	{
		gint i = 0;
#line 182 "../src/ImageManager.vala"
		i = 0;
#line 604 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 182 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 182 "../src/ImageManager.vala"
			while (TRUE) {
#line 611 "ImageManager.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				ImageManagerImageItem* _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
#line 182 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 619 "ImageManager.c"
					gint _tmp1_;
#line 182 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 182 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 625 "ImageManager.c"
				}
#line 182 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 182 "../src/ImageManager.vala"
				_tmp2_ = self->priv->_images;
#line 182 "../src/ImageManager.vala"
				if (!(((guint) i) < _tmp2_->len)) {
#line 182 "../src/ImageManager.vala"
					break;
#line 635 "ImageManager.c"
				}
#line 183 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 183 "../src/ImageManager.vala"
				_tmp4_ = g_array_index (_tmp3_, ImageManagerImageItem*, (guint) i);
#line 183 "../src/ImageManager.vala"
				_tmp5_ = image_manager_image_item_get_uri (_tmp4_);
#line 183 "../src/ImageManager.vala"
				_tmp6_ = _tmp5_;
#line 183 "../src/ImageManager.vala"
				if (g_strcmp0 (_tmp6_, uri) == 0) {
#line 647 "ImageManager.c"
					GArray* _tmp7_;
					ImageManagerImageItem* _tmp8_;
					ImageManagerImageItem* _tmp9_;
#line 184 "../src/ImageManager.vala"
					_tmp7_ = self->priv->_images;
#line 184 "../src/ImageManager.vala"
					_tmp8_ = g_array_index (_tmp7_, ImageManagerImageItem*, (guint) i);
#line 184 "../src/ImageManager.vala"
					_tmp9_ = _image_manager_image_item_ref0 (_tmp8_);
#line 184 "../src/ImageManager.vala"
					result = _tmp9_;
#line 184 "../src/ImageManager.vala"
					return result;
#line 661 "ImageManager.c"
				}
			}
		}
	}
#line 187 "../src/ImageManager.vala"
	result = NULL;
#line 187 "../src/ImageManager.vala"
	return result;
#line 670 "ImageManager.c"
}

gint
image_manager_add_image (ImageManager* self,
                         const gchar* uri,
                         gint* orig_id)
{
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
	ImageManagerImageItem* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint result;
#line 195 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 195 "../src/ImageManager.vala"
	g_return_val_if_fail (uri != NULL, 0);
#line 196 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_uri_match (self, uri);
#line 196 "../src/ImageManager.vala"
	item = _tmp0_;
#line 197 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 197 "../src/ImageManager.vala"
	if (_tmp1_ == NULL) {
#line 697 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
		ImageManagerImageItem* _tmp3_;
		GArray* _tmp4_;
		ImageManagerImageItem* _tmp5_;
		ImageManagerImageItem* _tmp6_;
#line 198 "../src/ImageManager.vala"
		_tmp2_ = image_manager_image_item_new (uri);
#line 198 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 198 "../src/ImageManager.vala"
		item = _tmp2_;
#line 199 "../src/ImageManager.vala"
		_tmp3_ = item;
#line 199 "../src/ImageManager.vala"
		if (!image_manager_image_item_copy_file (_tmp3_)) {
#line 199 "../src/ImageManager.vala"
			result = -1;
#line 199 "../src/ImageManager.vala"
			_image_manager_image_item_unref0 (item);
#line 199 "../src/ImageManager.vala"
			return result;
#line 719 "ImageManager.c"
		}
#line 200 "../src/ImageManager.vala"
		_tmp4_ = self->priv->_images;
#line 200 "../src/ImageManager.vala"
		_tmp5_ = item;
#line 200 "../src/ImageManager.vala"
		_tmp6_ = _image_manager_image_item_ref0 (_tmp5_);
#line 200 "../src/ImageManager.vala"
		g_array_append_val (_tmp4_, _tmp6_);
#line 729 "ImageManager.c"
	} else {
		ImageManagerImageItem* _tmp7_;
#line 201 "../src/ImageManager.vala"
		_tmp7_ = item;
#line 201 "../src/ImageManager.vala"
		if (!image_manager_image_item_exists (_tmp7_)) {
#line 736 "ImageManager.c"
			ImageManagerImageItem* _tmp8_;
#line 202 "../src/ImageManager.vala"
			_tmp8_ = item;
#line 202 "../src/ImageManager.vala"
			if (!image_manager_image_item_copy_file (_tmp8_)) {
#line 202 "../src/ImageManager.vala"
				result = -1;
#line 202 "../src/ImageManager.vala"
				_image_manager_image_item_unref0 (item);
#line 202 "../src/ImageManager.vala"
				return result;
#line 748 "ImageManager.c"
			}
		}
	}
#line 204 "../src/ImageManager.vala"
	if (orig_id != NULL) {
#line 754 "ImageManager.c"
		GeeHashMap* _tmp9_;
		ImageManagerImageItem* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 205 "../src/ImageManager.vala"
		_tmp9_ = self->priv->_id_map;
#line 205 "../src/ImageManager.vala"
		_tmp10_ = item;
#line 205 "../src/ImageManager.vala"
		_tmp11_ = image_manager_image_item_get_id (_tmp10_);
#line 205 "../src/ImageManager.vala"
		_tmp12_ = _tmp11_;
#line 205 "../src/ImageManager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) (*orig_id)), (gpointer) ((gintptr) _tmp12_));
#line 769 "ImageManager.c"
	}
#line 207 "../src/ImageManager.vala"
	_tmp13_ = item;
#line 207 "../src/ImageManager.vala"
	_tmp14_ = image_manager_image_item_get_id (_tmp13_);
#line 207 "../src/ImageManager.vala"
	_tmp15_ = _tmp14_;
#line 207 "../src/ImageManager.vala"
	result = _tmp15_;
#line 207 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 207 "../src/ImageManager.vala"
	return result;
#line 783 "ImageManager.c"
}

gint
image_manager_add_pixbuf (ImageManager* self,
                          GdkPixbuf* buf,
                          gint* orig_id)
{
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 216 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 216 "../src/ImageManager.vala"
	g_return_val_if_fail (buf != NULL, 0);
#line 217 "../src/ImageManager.vala"
	_tmp0_ = image_manager_image_item_new ("");
#line 217 "../src/ImageManager.vala"
	item = _tmp0_;
#line 806 "ImageManager.c"
	{
		ImageManagerImageItem* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GArray* _tmp4_;
		ImageManagerImageItem* _tmp5_;
		ImageManagerImageItem* _tmp6_;
#line 219 "../src/ImageManager.vala"
		_tmp1_ = item;
#line 219 "../src/ImageManager.vala"
		_tmp2_ = image_manager_image_item_get_path (_tmp1_);
#line 219 "../src/ImageManager.vala"
		_tmp3_ = _tmp2_;
#line 219 "../src/ImageManager.vala"
		gdk_pixbuf_save (buf, _tmp3_, "png", &_inner_error0_, NULL, NULL);
#line 219 "../src/ImageManager.vala"
		_g_free0 (_tmp3_);
#line 219 "../src/ImageManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 826 "ImageManager.c"
			goto __catch0_g_error;
		}
#line 220 "../src/ImageManager.vala"
		_tmp4_ = self->priv->_images;
#line 220 "../src/ImageManager.vala"
		_tmp5_ = item;
#line 220 "../src/ImageManager.vala"
		_tmp6_ = _image_manager_image_item_ref0 (_tmp5_);
#line 220 "../src/ImageManager.vala"
		g_array_append_val (_tmp4_, _tmp6_);
#line 837 "ImageManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 218 "../src/ImageManager.vala"
		g_clear_error (&_inner_error0_);
#line 222 "../src/ImageManager.vala"
		result = -1;
#line 222 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 222 "../src/ImageManager.vala"
		return result;
#line 850 "ImageManager.c"
	}
	__finally0:
#line 218 "../src/ImageManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 855 "ImageManager.c"
		gint _tmp7_ = -1;
#line 218 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 218 "../src/ImageManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "../src/ImageManager.vala"
		g_clear_error (&_inner_error0_);
#line 218 "../src/ImageManager.vala"
		return _tmp7_;
#line 865 "ImageManager.c"
	}
#line 224 "../src/ImageManager.vala"
	_tmp8_ = item;
#line 224 "../src/ImageManager.vala"
	_tmp9_ = image_manager_image_item_get_id (_tmp8_);
#line 224 "../src/ImageManager.vala"
	_tmp10_ = _tmp9_;
#line 224 "../src/ImageManager.vala"
	result = _tmp10_;
#line 224 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 224 "../src/ImageManager.vala"
	return result;
#line 879 "ImageManager.c"
}

gchar*
image_manager_get_file (ImageManager* self,
                        gint id)
{
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
	gchar* result;
#line 228 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_match (self, id);
#line 229 "../src/ImageManager.vala"
	item = _tmp0_;
#line 230 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 230 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 900 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
		gchar* _tmp3_;
#line 231 "../src/ImageManager.vala"
		_tmp2_ = item;
#line 231 "../src/ImageManager.vala"
		_tmp3_ = image_manager_image_item_get_path (_tmp2_);
#line 231 "../src/ImageManager.vala"
		result = _tmp3_;
#line 231 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 231 "../src/ImageManager.vala"
		return result;
#line 913 "ImageManager.c"
	}
#line 233 "../src/ImageManager.vala"
	result = NULL;
#line 233 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 233 "../src/ImageManager.vala"
	return result;
#line 921 "ImageManager.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 944 "ImageManager.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 953 "ImageManager.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 972 "ImageManager.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 976 "ImageManager.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 982 "ImageManager.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 992 "ImageManager.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1000 "ImageManager.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1004 "ImageManager.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 1010 "ImageManager.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 1020 "ImageManager.c"
}

gchar*
image_manager_get_mime_type (ImageManager* self,
                             gint id)
{
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
	gchar* result;
#line 237 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 238 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_match (self, id);
#line 238 "../src/ImageManager.vala"
	item = _tmp0_;
#line 239 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 239 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 1041 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 240 "../src/ImageManager.vala"
		_tmp2_ = item;
#line 240 "../src/ImageManager.vala"
		_tmp3_ = image_manager_image_item_get_extension (_tmp2_);
#line 240 "../src/ImageManager.vala"
		_tmp4_ = _tmp3_;
#line 240 "../src/ImageManager.vala"
		_tmp5_ = string_substring (_tmp4_, (glong) 1, (glong) -1);
#line 240 "../src/ImageManager.vala"
		_tmp6_ = _tmp5_;
#line 240 "../src/ImageManager.vala"
		_tmp7_ = g_strdup_printf ("image/%s", _tmp6_);
#line 240 "../src/ImageManager.vala"
		_tmp8_ = _tmp7_;
#line 240 "../src/ImageManager.vala"
		_g_free0 (_tmp6_);
#line 240 "../src/ImageManager.vala"
		_g_free0 (_tmp4_);
#line 240 "../src/ImageManager.vala"
		result = _tmp8_;
#line 240 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 240 "../src/ImageManager.vala"
		return result;
#line 1073 "ImageManager.c"
	}
#line 242 "../src/ImageManager.vala"
	result = NULL;
#line 242 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 242 "../src/ImageManager.vala"
	return result;
#line 1081 "ImageManager.c"
}

GArray*
image_manager_get_ids (ImageManager* self)
{
	GArray* ids = NULL;
	GArray* _tmp0_;
	GArray* result;
#line 246 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "../src/ImageManager.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gint));
#line 247 "../src/ImageManager.vala"
	ids = _tmp0_;
#line 1096 "ImageManager.c"
	{
		gint i = 0;
#line 248 "../src/ImageManager.vala"
		i = 0;
#line 1101 "ImageManager.c"
		{
			gboolean _tmp1_ = FALSE;
#line 248 "../src/ImageManager.vala"
			_tmp1_ = TRUE;
#line 248 "../src/ImageManager.vala"
			while (TRUE) {
#line 1108 "ImageManager.c"
				GArray* _tmp3_;
				GArray* _tmp4_;
				GArray* _tmp5_;
				ImageManagerImageItem* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 248 "../src/ImageManager.vala"
				if (!_tmp1_) {
#line 1117 "ImageManager.c"
					gint _tmp2_;
#line 248 "../src/ImageManager.vala"
					_tmp2_ = i;
#line 248 "../src/ImageManager.vala"
					i = _tmp2_ + 1;
#line 1123 "ImageManager.c"
				}
#line 248 "../src/ImageManager.vala"
				_tmp1_ = FALSE;
#line 248 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 248 "../src/ImageManager.vala"
				if (!(((guint) i) < _tmp3_->len)) {
#line 248 "../src/ImageManager.vala"
					break;
#line 1133 "ImageManager.c"
				}
#line 249 "../src/ImageManager.vala"
				_tmp4_ = ids;
#line 249 "../src/ImageManager.vala"
				_tmp5_ = self->priv->_images;
#line 249 "../src/ImageManager.vala"
				_tmp6_ = g_array_index (_tmp5_, ImageManagerImageItem*, (guint) i);
#line 249 "../src/ImageManager.vala"
				_tmp7_ = image_manager_image_item_get_id (_tmp6_);
#line 249 "../src/ImageManager.vala"
				_tmp8_ = _tmp7_;
#line 249 "../src/ImageManager.vala"
				g_array_append_val (_tmp4_, _tmp8_);
#line 1147 "ImageManager.c"
			}
		}
	}
#line 251 "../src/ImageManager.vala"
	result = ids;
#line 251 "../src/ImageManager.vala"
	return result;
#line 1155 "ImageManager.c"
}

gchar*
image_manager_get_uri (ImageManager* self,
                       gint id)
{
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
	gchar* _tmp6_;
	gchar* result;
#line 255 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_match (self, id);
#line 256 "../src/ImageManager.vala"
	item = _tmp0_;
#line 257 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 257 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 1177 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 258 "../src/ImageManager.vala"
		_tmp2_ = item;
#line 258 "../src/ImageManager.vala"
		_tmp3_ = image_manager_image_item_get_uri (_tmp2_);
#line 258 "../src/ImageManager.vala"
		_tmp4_ = _tmp3_;
#line 258 "../src/ImageManager.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 258 "../src/ImageManager.vala"
		result = _tmp5_;
#line 258 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 258 "../src/ImageManager.vala"
		return result;
#line 1196 "ImageManager.c"
	}
#line 260 "../src/ImageManager.vala"
	_tmp6_ = g_strdup ("");
#line 260 "../src/ImageManager.vala"
	result = _tmp6_;
#line 260 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 260 "../src/ImageManager.vala"
	return result;
#line 1206 "ImageManager.c"
}

void
image_manager_set_valid (ImageManager* self,
                         gint id,
                         gboolean value)
{
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
#line 268 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_match (self, id);
#line 269 "../src/ImageManager.vala"
	item = _tmp0_;
#line 270 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 270 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 1227 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
#line 271 "../src/ImageManager.vala"
		_tmp2_ = item;
#line 271 "../src/ImageManager.vala"
		image_manager_image_item_set_valid (_tmp2_, value);
#line 1233 "ImageManager.c"
	}
#line 268 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 1237 "ImageManager.c"
}

void
image_manager_cleanup (ImageManager* self)
{
#line 276 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 1245 "ImageManager.c"
	{
		gint i = 0;
#line 277 "../src/ImageManager.vala"
		i = 0;
#line 1250 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 277 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 277 "../src/ImageManager.vala"
			while (TRUE) {
#line 1257 "ImageManager.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				ImageManagerImageItem* _tmp4_;
#line 277 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 1263 "ImageManager.c"
					gint _tmp1_;
#line 277 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 277 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 1269 "ImageManager.c"
				}
#line 277 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 277 "../src/ImageManager.vala"
				_tmp2_ = self->priv->_images;
#line 277 "../src/ImageManager.vala"
				if (!(((guint) i) < _tmp2_->len)) {
#line 277 "../src/ImageManager.vala"
					break;
#line 1279 "ImageManager.c"
				}
#line 278 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 278 "../src/ImageManager.vala"
				_tmp4_ = g_array_index (_tmp3_, ImageManagerImageItem*, (guint) i);
#line 278 "../src/ImageManager.vala"
				image_manager_image_item_cleanup (_tmp4_);
#line 1287 "ImageManager.c"
			}
		}
	}
}

gint
image_manager_get_id (ImageManager* self,
                      gint id)
{
	GeeHashMap* _tmp0_;
	gint result;
#line 283 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 284 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_id_map;
#line 284 "../src/ImageManager.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) id))) {
#line 1305 "ImageManager.c"
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
#line 285 "../src/ImageManager.vala"
		_tmp1_ = self->priv->_id_map;
#line 285 "../src/ImageManager.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) id));
#line 285 "../src/ImageManager.vala"
		result = (gint) ((gintptr) _tmp2_);
#line 285 "../src/ImageManager.vala"
		return result;
#line 1316 "ImageManager.c"
	}
#line 287 "../src/ImageManager.vala"
	result = id;
#line 287 "../src/ImageManager.vala"
	return result;
#line 1322 "ImageManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 310 "../src/ImageManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 1330 "ImageManager.c"
}

gint
image_manager_choose_image (ImageManager* self,
                            GtkWindow* parent)
{
	gint id = 0;
	GtkFileChooserNative* dialog = NULL;
	GtkFileChooserNative* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* _tmp6_;
	GtkFileFilter* _tmp7_;
	GtkFileFilter* _tmp8_;
	GtkFileChooserNative* _tmp9_;
	GtkFileFilter* _tmp10_;
	GtkFileFilter* _tmp11_;
	GtkFileChooserNative* _tmp12_;
	GtkFileChooserNative* _tmp19_;
	gint result;
#line 295 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 295 "../src/ImageManager.vala"
	g_return_val_if_fail (parent != NULL, 0);
#line 297 "../src/ImageManager.vala"
	id = -1;
#line 299 "../src/ImageManager.vala"
	_tmp0_ = gtk_file_chooser_native_new (_ ("Select Image"), parent, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Select"), _ ("Cancel"));
#line 299 "../src/ImageManager.vala"
	dialog = _tmp0_;
#line 300 "../src/ImageManager.vala"
	_tmp1_ = dialog;
#line 300 "../src/ImageManager.vala"
	utils_set_chooser_folder ((GtkFileChooser*) _tmp1_);
#line 303 "../src/ImageManager.vala"
	_tmp2_ = gtk_file_filter_new ();
#line 303 "../src/ImageManager.vala"
	g_object_ref_sink (_tmp2_);
#line 303 "../src/ImageManager.vala"
	filter = _tmp2_;
#line 304 "../src/ImageManager.vala"
	_tmp3_ = filter;
#line 304 "../src/ImageManager.vala"
	gtk_file_filter_set_name (_tmp3_, _ ("Images"));
#line 305 "../src/ImageManager.vala"
	_tmp4_ = filter;
#line 305 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp4_, "*.bmp");
#line 306 "../src/ImageManager.vala"
	_tmp5_ = filter;
#line 306 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp5_, "*.png");
#line 307 "../src/ImageManager.vala"
	_tmp6_ = filter;
#line 307 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp6_, "*.jpg");
#line 308 "../src/ImageManager.vala"
	_tmp7_ = filter;
#line 308 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp7_, "*.jpeg");
#line 309 "../src/ImageManager.vala"
	_tmp8_ = filter;
#line 309 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp8_, "*.svg");
#line 310 "../src/ImageManager.vala"
	_tmp9_ = dialog;
#line 310 "../src/ImageManager.vala"
	_tmp10_ = filter;
#line 310 "../src/ImageManager.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 310 "../src/ImageManager.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp9_, _tmp11_);
#line 312 "../src/ImageManager.vala"
	_tmp12_ = dialog;
#line 312 "../src/ImageManager.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp12_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1411 "ImageManager.c"
		GtkFileChooserNative* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GtkFileChooserNative* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 313 "../src/ImageManager.vala"
		_tmp13_ = dialog;
#line 313 "../src/ImageManager.vala"
		_tmp14_ = gtk_file_chooser_get_uri ((GtkFileChooser*) _tmp13_);
#line 313 "../src/ImageManager.vala"
		_tmp15_ = _tmp14_;
#line 313 "../src/ImageManager.vala"
		id = image_manager_add_image (self, _tmp15_, NULL);
#line 313 "../src/ImageManager.vala"
		_g_free0 (_tmp15_);
#line 314 "../src/ImageManager.vala"
		_tmp16_ = dialog;
#line 314 "../src/ImageManager.vala"
		_tmp17_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp16_);
#line 314 "../src/ImageManager.vala"
		_tmp18_ = _tmp17_;
#line 314 "../src/ImageManager.vala"
		utils_store_chooser_folder (_tmp18_);
#line 314 "../src/ImageManager.vala"
		_g_free0 (_tmp18_);
#line 1438 "ImageManager.c"
	}
#line 318 "../src/ImageManager.vala"
	_tmp19_ = dialog;
#line 318 "../src/ImageManager.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp19_);
#line 320 "../src/ImageManager.vala"
	result = id;
#line 320 "../src/ImageManager.vala"
	_g_object_unref0 (filter);
#line 320 "../src/ImageManager.vala"
	_g_object_unref0 (dialog);
#line 320 "../src/ImageManager.vala"
	return result;
#line 1452 "ImageManager.c"
}

static inline gpointer
image_manager_image_item_get_instance_private (ImageManagerImageItem* self)
{
	return G_STRUCT_MEMBER_P (self, ImageManagerImageItem_private_offset);
}

static ImageManagerImageItem*
image_manager_image_item_construct (GType object_type,
                                    const gchar* uri)
{
	ImageManagerImageItem* self = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GSettings* _tmp3_;
	gint _tmp4_;
#line 42 "../src/ImageManager.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 42 "../src/ImageManager.vala"
	self = (ImageManagerImageItem*) g_type_create_instance (object_type);
#line 43 "../src/ImageManager.vala"
	_tmp0_ = minder_settings;
#line 43 "../src/ImageManager.vala"
	image_manager_image_item_set_id (self, g_settings_get_int (_tmp0_, "image-id"));
#line 44 "../src/ImageManager.vala"
	image_manager_image_item_set_uri (self, uri);
#line 45 "../src/ImageManager.vala"
	_tmp1_ = image_manager_image_item_get_extension (self);
#line 45 "../src/ImageManager.vala"
	_tmp2_ = _tmp1_;
#line 45 "../src/ImageManager.vala"
	image_manager_image_item_set_ext (self, _tmp2_);
#line 45 "../src/ImageManager.vala"
	_g_free0 (_tmp2_);
#line 46 "../src/ImageManager.vala"
	image_manager_image_item_set_valid (self, TRUE);
#line 47 "../src/ImageManager.vala"
	_tmp3_ = minder_settings;
#line 47 "../src/ImageManager.vala"
	_tmp4_ = self->priv->_id;
#line 47 "../src/ImageManager.vala"
	g_settings_set_int (_tmp3_, "image-id", _tmp4_ + 1);
#line 42 "../src/ImageManager.vala"
	return self;
#line 1499 "ImageManager.c"
}

static ImageManagerImageItem*
image_manager_image_item_new (const gchar* uri)
{
#line 42 "../src/ImageManager.vala"
	return image_manager_image_item_construct (IMAGE_MANAGER_TYPE_IMAGE_ITEM, uri);
#line 1507 "ImageManager.c"
}

static ImageManagerImageItem*
image_manager_image_item_construct_from_xml (GType object_type,
                                             xmlNode* n)
{
	ImageManagerImageItem* self = NULL;
	gchar* i = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* u = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* e = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
#line 51 "../src/ImageManager.vala"
	self = (ImageManagerImageItem*) g_type_create_instance (object_type);
#line 52 "../src/ImageManager.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "id");
#line 52 "../src/ImageManager.vala"
	i = _tmp0_;
#line 53 "../src/ImageManager.vala"
	_tmp1_ = i;
#line 53 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 1534 "ImageManager.c"
		const gchar* _tmp2_;
#line 54 "../src/ImageManager.vala"
		_tmp2_ = i;
#line 54 "../src/ImageManager.vala"
		image_manager_image_item_set_id (self, atoi (_tmp2_));
#line 1540 "ImageManager.c"
	}
#line 56 "../src/ImageManager.vala"
	_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "uri");
#line 56 "../src/ImageManager.vala"
	u = _tmp3_;
#line 57 "../src/ImageManager.vala"
	_tmp4_ = u;
#line 57 "../src/ImageManager.vala"
	if (_tmp4_ != NULL) {
#line 1550 "ImageManager.c"
		const gchar* _tmp5_;
#line 58 "../src/ImageManager.vala"
		_tmp5_ = u;
#line 58 "../src/ImageManager.vala"
		image_manager_image_item_set_uri (self, _tmp5_);
#line 1556 "ImageManager.c"
	}
#line 60 "../src/ImageManager.vala"
	_tmp6_ = (gchar*) xmlGetProp (n, (xmlChar*) "ext");
#line 60 "../src/ImageManager.vala"
	e = _tmp6_;
#line 61 "../src/ImageManager.vala"
	_tmp7_ = e;
#line 61 "../src/ImageManager.vala"
	if (_tmp7_ != NULL) {
#line 1566 "ImageManager.c"
		const gchar* _tmp8_;
#line 62 "../src/ImageManager.vala"
		_tmp8_ = e;
#line 62 "../src/ImageManager.vala"
		image_manager_image_item_set_ext (self, _tmp8_);
#line 1572 "ImageManager.c"
	}
#line 64 "../src/ImageManager.vala"
	image_manager_image_item_set_valid (self, TRUE);
#line 51 "../src/ImageManager.vala"
	_g_free0 (e);
#line 51 "../src/ImageManager.vala"
	_g_free0 (u);
#line 51 "../src/ImageManager.vala"
	_g_free0 (i);
#line 51 "../src/ImageManager.vala"
	return self;
#line 1584 "ImageManager.c"
}

static ImageManagerImageItem*
image_manager_image_item_new_from_xml (xmlNode* n)
{
#line 51 "../src/ImageManager.vala"
	return image_manager_image_item_construct_from_xml (IMAGE_MANAGER_TYPE_IMAGE_ITEM, n);
#line 1592 "ImageManager.c"
}

static void
image_manager_image_item_save (ImageManagerImageItem* self,
                               xmlNode* parent)
{
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 68 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/ImageManager.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "image");
#line 69 "../src/ImageManager.vala"
	n = _tmp0_;
#line 70 "../src/ImageManager.vala"
	_tmp1_ = self->priv->_id;
#line 70 "../src/ImageManager.vala"
	_tmp2_ = g_strdup_printf ("%i", _tmp1_);
#line 70 "../src/ImageManager.vala"
	_tmp3_ = _tmp2_;
#line 70 "../src/ImageManager.vala"
	xmlNewProp (n, (xmlChar*) "id", (xmlChar*) _tmp3_);
#line 70 "../src/ImageManager.vala"
	_g_free0 (_tmp3_);
#line 71 "../src/ImageManager.vala"
	_tmp4_ = self->priv->_uri;
#line 71 "../src/ImageManager.vala"
	xmlNewProp (n, (xmlChar*) "uri", (xmlChar*) _tmp4_);
#line 72 "../src/ImageManager.vala"
	_tmp5_ = self->priv->_ext;
#line 72 "../src/ImageManager.vala"
	xmlNewProp (n, (xmlChar*) "ext", (xmlChar*) _tmp5_);
#line 73 "../src/ImageManager.vala"
	xmlAddChild (parent, n);
#line 1632 "ImageManager.c"
}

static gboolean
image_manager_image_item_exists (ImageManagerImageItem* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 77 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../src/ImageManager.vala"
	_tmp0_ = image_manager_image_item_get_path (self);
#line 78 "../src/ImageManager.vala"
	_tmp1_ = _tmp0_;
#line 78 "../src/ImageManager.vala"
	_tmp2_ = g_file_test (_tmp1_, G_FILE_TEST_EXISTS);
#line 78 "../src/ImageManager.vala"
	_g_free0 (_tmp1_);
#line 78 "../src/ImageManager.vala"
	result = _tmp2_;
#line 78 "../src/ImageManager.vala"
	return result;
#line 1656 "ImageManager.c"
}

static gchar*
image_manager_image_item_get_extension (ImageManagerImageItem* self)
{
	const gchar* _tmp0_;
	gchar* _tmp25_;
	gchar* result;
#line 82 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_uri;
#line 83 "../src/ImageManager.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 1671 "ImageManager.c"
		gchar** parts = NULL;
		const gchar* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint parts_length1;
		gint _parts_size_;
		gchar* ext = NULL;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		const gchar* _tmp17_;
#line 84 "../src/ImageManager.vala"
		_tmp1_ = self->priv->_uri;
#line 84 "../src/ImageManager.vala"
		_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ".", 0);
#line 84 "../src/ImageManager.vala"
		parts = _tmp3_;
#line 84 "../src/ImageManager.vala"
		parts_length1 = _vala_array_length (_tmp2_);
#line 84 "../src/ImageManager.vala"
		_parts_size_ = parts_length1;
#line 85 "../src/ImageManager.vala"
		_tmp4_ = parts;
#line 85 "../src/ImageManager.vala"
		_tmp4__length1 = parts_length1;
#line 85 "../src/ImageManager.vala"
		_tmp5_ = parts;
#line 85 "../src/ImageManager.vala"
		_tmp5__length1 = parts_length1;
#line 85 "../src/ImageManager.vala"
		_tmp6_ = _tmp4_[_tmp5__length1 - 1];
#line 85 "../src/ImageManager.vala"
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "?", 0);
#line 85 "../src/ImageManager.vala"
		_tmp9_ = _tmp8_;
#line 85 "../src/ImageManager.vala"
		_tmp9__length1 = _vala_array_length (_tmp7_);
#line 85 "../src/ImageManager.vala"
		_tmp10_ = _tmp9_[0];
#line 85 "../src/ImageManager.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 85 "../src/ImageManager.vala"
		_tmp12_ = _tmp11_;
#line 85 "../src/ImageManager.vala"
		_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/ImageManager.vala"
		ext = _tmp12_;
#line 86 "../src/ImageManager.vala"
		_tmp17_ = ext;
#line 86 "../src/ImageManager.vala"
		if (g_strcmp0 (_tmp17_, "bmp") == 0) {
#line 86 "../src/ImageManager.vala"
			_tmp16_ = TRUE;
#line 1738 "ImageManager.c"
		} else {
			const gchar* _tmp18_;
#line 86 "../src/ImageManager.vala"
			_tmp18_ = ext;
#line 86 "../src/ImageManager.vala"
			_tmp16_ = g_strcmp0 (_tmp18_, "png") == 0;
#line 1745 "ImageManager.c"
		}
#line 86 "../src/ImageManager.vala"
		if (_tmp16_) {
#line 86 "../src/ImageManager.vala"
			_tmp15_ = TRUE;
#line 1751 "ImageManager.c"
		} else {
			const gchar* _tmp19_;
#line 86 "../src/ImageManager.vala"
			_tmp19_ = ext;
#line 86 "../src/ImageManager.vala"
			_tmp15_ = g_strcmp0 (_tmp19_, "jpg") == 0;
#line 1758 "ImageManager.c"
		}
#line 86 "../src/ImageManager.vala"
		if (_tmp15_) {
#line 86 "../src/ImageManager.vala"
			_tmp14_ = TRUE;
#line 1764 "ImageManager.c"
		} else {
			const gchar* _tmp20_;
#line 86 "../src/ImageManager.vala"
			_tmp20_ = ext;
#line 86 "../src/ImageManager.vala"
			_tmp14_ = g_strcmp0 (_tmp20_, "jpeg") == 0;
#line 1771 "ImageManager.c"
		}
#line 86 "../src/ImageManager.vala"
		if (_tmp14_) {
#line 86 "../src/ImageManager.vala"
			_tmp13_ = TRUE;
#line 1777 "ImageManager.c"
		} else {
			const gchar* _tmp21_;
#line 86 "../src/ImageManager.vala"
			_tmp21_ = ext;
#line 86 "../src/ImageManager.vala"
			_tmp13_ = g_strcmp0 (_tmp21_, "svg") == 0;
#line 1784 "ImageManager.c"
		}
#line 86 "../src/ImageManager.vala"
		if (_tmp13_) {
#line 1788 "ImageManager.c"
			const gchar* _tmp22_;
			gchar* _tmp23_;
#line 87 "../src/ImageManager.vala"
			_tmp22_ = ext;
#line 87 "../src/ImageManager.vala"
			_tmp23_ = g_strconcat (".", _tmp22_, NULL);
#line 87 "../src/ImageManager.vala"
			result = _tmp23_;
#line 87 "../src/ImageManager.vala"
			_g_free0 (ext);
#line 87 "../src/ImageManager.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 87 "../src/ImageManager.vala"
			return result;
#line 1803 "ImageManager.c"
		}
#line 83 "../src/ImageManager.vala"
		_g_free0 (ext);
#line 83 "../src/ImageManager.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1809 "ImageManager.c"
	} else {
		gchar* _tmp24_;
#line 90 "../src/ImageManager.vala"
		_tmp24_ = g_strdup (".png");
#line 90 "../src/ImageManager.vala"
		result = _tmp24_;
#line 90 "../src/ImageManager.vala"
		return result;
#line 1818 "ImageManager.c"
	}
#line 92 "../src/ImageManager.vala"
	_tmp25_ = g_strdup ("");
#line 92 "../src/ImageManager.vala"
	result = _tmp25_;
#line 92 "../src/ImageManager.vala"
	return result;
#line 1826 "ImageManager.c"
}

static gchar*
image_manager_image_item_get_path (ImageManagerImageItem* self)
{
	gchar* basename = NULL;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 96 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_id;
#line 97 "../src/ImageManager.vala"
	_tmp1_ = self->priv->_ext;
#line 97 "../src/ImageManager.vala"
	_tmp2_ = g_strdup_printf ("img%06x%s", (guint) _tmp0_, _tmp1_);
#line 97 "../src/ImageManager.vala"
	basename = _tmp2_;
#line 98 "../src/ImageManager.vala"
	_tmp3_ = image_manager_get_storage_path ();
#line 98 "../src/ImageManager.vala"
	_tmp4_ = _tmp3_;
#line 98 "../src/ImageManager.vala"
	_tmp5_ = g_build_filename (_tmp4_, basename, NULL);
#line 98 "../src/ImageManager.vala"
	_tmp6_ = _tmp5_;
#line 98 "../src/ImageManager.vala"
	_g_free0 (_tmp4_);
#line 98 "../src/ImageManager.vala"
	result = _tmp6_;
#line 98 "../src/ImageManager.vala"
	_g_free0 (basename);
#line 98 "../src/ImageManager.vala"
	return result;
#line 1867 "ImageManager.c"
}

static gboolean
image_manager_image_item_copy_file (ImageManagerImageItem* self)
{
	GFile* rfile = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* lfile = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 102 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 103 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_uri;
#line 103 "../src/ImageManager.vala"
	_tmp1_ = g_file_new_for_uri (_tmp0_);
#line 103 "../src/ImageManager.vala"
	rfile = _tmp1_;
#line 104 "../src/ImageManager.vala"
	_tmp2_ = image_manager_image_item_get_path (self);
#line 104 "../src/ImageManager.vala"
	_tmp3_ = _tmp2_;
#line 104 "../src/ImageManager.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 104 "../src/ImageManager.vala"
	_tmp5_ = _tmp4_;
#line 104 "../src/ImageManager.vala"
	_g_free0 (_tmp3_);
#line 104 "../src/ImageManager.vala"
	lfile = _tmp5_;
#line 1903 "ImageManager.c"
	{
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 106 "../src/ImageManager.vala"
		_tmp6_ = rfile;
#line 106 "../src/ImageManager.vala"
		_tmp7_ = lfile;
#line 106 "../src/ImageManager.vala"
		g_file_copy (_tmp6_, _tmp7_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 106 "../src/ImageManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1915 "ImageManager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 105 "../src/ImageManager.vala"
		g_clear_error (&_inner_error0_);
#line 108 "../src/ImageManager.vala"
		result = FALSE;
#line 108 "../src/ImageManager.vala"
		_g_object_unref0 (lfile);
#line 108 "../src/ImageManager.vala"
		_g_object_unref0 (rfile);
#line 108 "../src/ImageManager.vala"
		return result;
#line 1932 "ImageManager.c"
	}
	__finally0:
#line 105 "../src/ImageManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1937 "ImageManager.c"
		gboolean _tmp8_ = FALSE;
#line 105 "../src/ImageManager.vala"
		_g_object_unref0 (lfile);
#line 105 "../src/ImageManager.vala"
		_g_object_unref0 (rfile);
#line 105 "../src/ImageManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/ImageManager.vala"
		g_clear_error (&_inner_error0_);
#line 105 "../src/ImageManager.vala"
		return _tmp8_;
#line 1949 "ImageManager.c"
	}
#line 110 "../src/ImageManager.vala"
	result = TRUE;
#line 110 "../src/ImageManager.vala"
	_g_object_unref0 (lfile);
#line 110 "../src/ImageManager.vala"
	_g_object_unref0 (rfile);
#line 110 "../src/ImageManager.vala"
	return result;
#line 1959 "ImageManager.c"
}

static void
image_manager_image_item_cleanup (ImageManagerImageItem* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 114 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/ImageManager.vala"
	_tmp1_ = self->priv->_valid;
#line 115 "../src/ImageManager.vala"
	if (!_tmp1_) {
#line 115 "../src/ImageManager.vala"
		_tmp0_ = image_manager_image_item_exists (self);
#line 1975 "ImageManager.c"
	} else {
#line 115 "../src/ImageManager.vala"
		_tmp0_ = FALSE;
#line 1979 "ImageManager.c"
	}
#line 115 "../src/ImageManager.vala"
	if (_tmp0_) {
#line 1983 "ImageManager.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 116 "../src/ImageManager.vala"
		_tmp2_ = image_manager_image_item_get_path (self);
#line 116 "../src/ImageManager.vala"
		_tmp3_ = _tmp2_;
#line 116 "../src/ImageManager.vala"
		g_unlink (_tmp3_);
#line 116 "../src/ImageManager.vala"
		_g_free0 (_tmp3_);
#line 1994 "ImageManager.c"
	}
}

static gint
image_manager_image_item_get_id (ImageManagerImageItem* self)
{
	gint result;
#line 36 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../src/ImageManager.vala"
	result = self->priv->_id;
#line 36 "../src/ImageManager.vala"
	return result;
#line 2008 "ImageManager.c"
}

static void
image_manager_image_item_set_id (ImageManagerImageItem* self,
                                 gint value)
{
#line 36 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/ImageManager.vala"
	self->priv->_id = value;
#line 2019 "ImageManager.c"
}

static const gchar*
image_manager_image_item_get_uri (ImageManagerImageItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_uri;
#line 37 "../src/ImageManager.vala"
	result = _tmp0_;
#line 37 "../src/ImageManager.vala"
	return result;
#line 2035 "ImageManager.c"
}

static void
image_manager_image_item_set_uri (ImageManagerImageItem* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 37 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/ImageManager.vala"
	_tmp0_ = g_strdup (value);
#line 37 "../src/ImageManager.vala"
	_g_free0 (self->priv->_uri);
#line 37 "../src/ImageManager.vala"
	self->priv->_uri = _tmp0_;
#line 2051 "ImageManager.c"
}

static const gchar*
image_manager_image_item_get_ext (ImageManagerImageItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_ext;
#line 38 "../src/ImageManager.vala"
	result = _tmp0_;
#line 38 "../src/ImageManager.vala"
	return result;
#line 2067 "ImageManager.c"
}

static void
image_manager_image_item_set_ext (ImageManagerImageItem* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 38 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/ImageManager.vala"
	_tmp0_ = g_strdup (value);
#line 38 "../src/ImageManager.vala"
	_g_free0 (self->priv->_ext);
#line 38 "../src/ImageManager.vala"
	self->priv->_ext = _tmp0_;
#line 2083 "ImageManager.c"
}

static gboolean
image_manager_image_item_get_valid (ImageManagerImageItem* self)
{
	gboolean result;
#line 39 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "../src/ImageManager.vala"
	result = self->priv->_valid;
#line 39 "../src/ImageManager.vala"
	return result;
#line 2096 "ImageManager.c"
}

static void
image_manager_image_item_set_valid (ImageManagerImageItem* self,
                                    gboolean value)
{
#line 39 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/ImageManager.vala"
	self->priv->_valid = value;
#line 2107 "ImageManager.c"
}

static void
image_manager_value_image_item_init (GValue* value)
{
#line 34 "../src/ImageManager.vala"
	value->data[0].v_pointer = NULL;
#line 2115 "ImageManager.c"
}

static void
image_manager_value_image_item_free_value (GValue* value)
{
#line 34 "../src/ImageManager.vala"
	if (value->data[0].v_pointer) {
#line 34 "../src/ImageManager.vala"
		image_manager_image_item_unref (value->data[0].v_pointer);
#line 2125 "ImageManager.c"
	}
}

static void
image_manager_value_image_item_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 34 "../src/ImageManager.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = image_manager_image_item_ref (src_value->data[0].v_pointer);
#line 2137 "ImageManager.c"
	} else {
#line 34 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2141 "ImageManager.c"
	}
}

static gpointer
image_manager_value_image_item_peek_pointer (const GValue* value)
{
#line 34 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 2150 "ImageManager.c"
}

static gchar*
image_manager_value_image_item_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 34 "../src/ImageManager.vala"
	if (collect_values[0].v_pointer) {
#line 2161 "ImageManager.c"
		ImageManagerImageItem * object;
		object = collect_values[0].v_pointer;
#line 34 "../src/ImageManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "../src/ImageManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2168 "ImageManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "../src/ImageManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2172 "ImageManager.c"
		}
#line 34 "../src/ImageManager.vala"
		value->data[0].v_pointer = image_manager_image_item_ref (object);
#line 2176 "ImageManager.c"
	} else {
#line 34 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2180 "ImageManager.c"
	}
#line 34 "../src/ImageManager.vala"
	return NULL;
#line 2184 "ImageManager.c"
}

static gchar*
image_manager_value_image_item_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	ImageManagerImageItem ** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "../src/ImageManager.vala"
	if (!object_p) {
#line 34 "../src/ImageManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2199 "ImageManager.c"
	}
#line 34 "../src/ImageManager.vala"
	if (!value->data[0].v_pointer) {
#line 34 "../src/ImageManager.vala"
		*object_p = NULL;
#line 2205 "ImageManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "../src/ImageManager.vala"
		*object_p = value->data[0].v_pointer;
#line 2209 "ImageManager.c"
	} else {
#line 34 "../src/ImageManager.vala"
		*object_p = image_manager_image_item_ref (value->data[0].v_pointer);
#line 2213 "ImageManager.c"
	}
#line 34 "../src/ImageManager.vala"
	return NULL;
#line 2217 "ImageManager.c"
}

static GParamSpec*
image_manager_param_spec_image_item (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	ImageManagerParamSpecImageItem* spec;
#line 34 "../src/ImageManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, IMAGE_MANAGER_TYPE_IMAGE_ITEM), NULL);
#line 34 "../src/ImageManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "../src/ImageManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "../src/ImageManager.vala"
	return G_PARAM_SPEC (spec);
#line 2236 "ImageManager.c"
}

static gpointer
image_manager_value_get_image_item (const GValue* value)
{
#line 34 "../src/ImageManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IMAGE_MANAGER_TYPE_IMAGE_ITEM), NULL);
#line 34 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 2246 "ImageManager.c"
}

static void
image_manager_value_set_image_item (GValue* value,
                                    gpointer v_object)
{
	ImageManagerImageItem * old;
#line 34 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 34 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/ImageManager.vala"
	if (v_object) {
#line 34 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 34 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 34 "../src/ImageManager.vala"
		image_manager_image_item_ref (value->data[0].v_pointer);
#line 2268 "ImageManager.c"
	} else {
#line 34 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2272 "ImageManager.c"
	}
#line 34 "../src/ImageManager.vala"
	if (old) {
#line 34 "../src/ImageManager.vala"
		image_manager_image_item_unref (old);
#line 2278 "ImageManager.c"
	}
}

static void
image_manager_value_take_image_item (GValue* value,
                                     gpointer v_object)
{
	ImageManagerImageItem * old;
#line 34 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 34 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 34 "../src/ImageManager.vala"
	if (v_object) {
#line 34 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 34 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 2299 "ImageManager.c"
	} else {
#line 34 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2303 "ImageManager.c"
	}
#line 34 "../src/ImageManager.vala"
	if (old) {
#line 34 "../src/ImageManager.vala"
		image_manager_image_item_unref (old);
#line 2309 "ImageManager.c"
	}
}

static void
image_manager_image_item_class_init (ImageManagerImageItemClass * klass,
                                     gpointer klass_data)
{
#line 34 "../src/ImageManager.vala"
	image_manager_image_item_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/ImageManager.vala"
	((ImageManagerImageItemClass *) klass)->finalize = image_manager_image_item_finalize;
#line 34 "../src/ImageManager.vala"
	g_type_class_adjust_private_offset (klass, &ImageManagerImageItem_private_offset);
#line 2323 "ImageManager.c"
}

static void
image_manager_image_item_instance_init (ImageManagerImageItem * self,
                                        gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 34 "../src/ImageManager.vala"
	self->priv = image_manager_image_item_get_instance_private (self);
#line 36 "../src/ImageManager.vala"
	self->priv->_id = -1;
#line 37 "../src/ImageManager.vala"
	_tmp0_ = g_strdup ("");
#line 37 "../src/ImageManager.vala"
	self->priv->_uri = _tmp0_;
#line 38 "../src/ImageManager.vala"
	_tmp1_ = g_strdup ("");
#line 38 "../src/ImageManager.vala"
	self->priv->_ext = _tmp1_;
#line 39 "../src/ImageManager.vala"
	self->priv->_valid = FALSE;
#line 34 "../src/ImageManager.vala"
	self->ref_count = 1;
#line 2348 "ImageManager.c"
}

static void
image_manager_image_item_finalize (ImageManagerImageItem * obj)
{
	ImageManagerImageItem * self;
#line 34 "../src/ImageManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItem);
#line 34 "../src/ImageManager.vala"
	g_signal_handlers_destroy (self);
#line 37 "../src/ImageManager.vala"
	_g_free0 (self->priv->_uri);
#line 38 "../src/ImageManager.vala"
	_g_free0 (self->priv->_ext);
#line 2363 "ImageManager.c"
}

static GType
image_manager_image_item_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { image_manager_value_image_item_init, image_manager_value_image_item_free_value, image_manager_value_image_item_copy_value, image_manager_value_image_item_peek_pointer, "p", image_manager_value_image_item_collect_value, "p", image_manager_value_image_item_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ImageManagerImageItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_manager_image_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageManagerImageItem), 0, (GInstanceInitFunc) image_manager_image_item_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType image_manager_image_item_type_id;
	image_manager_image_item_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ImageManagerImageItem", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ImageManagerImageItem_private_offset = g_type_add_instance_private (image_manager_image_item_type_id, sizeof (ImageManagerImageItemPrivate));
	return image_manager_image_item_type_id;
}

static GType
image_manager_image_item_get_type (void)
{
	static volatile gsize image_manager_image_item_type_id__once = 0;
	if (g_once_init_enter (&image_manager_image_item_type_id__once)) {
		GType image_manager_image_item_type_id;
		image_manager_image_item_type_id = image_manager_image_item_get_type_once ();
		g_once_init_leave (&image_manager_image_item_type_id__once, image_manager_image_item_type_id);
	}
	return image_manager_image_item_type_id__once;
}

static gpointer
image_manager_image_item_ref (gpointer instance)
{
	ImageManagerImageItem * self;
	self = instance;
#line 34 "../src/ImageManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "../src/ImageManager.vala"
	return instance;
#line 2399 "ImageManager.c"
}

static void
image_manager_image_item_unref (gpointer instance)
{
	ImageManagerImageItem * self;
	self = instance;
#line 34 "../src/ImageManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "../src/ImageManager.vala"
		IMAGE_MANAGER_IMAGE_ITEM_GET_CLASS (self)->finalize (self);
#line 34 "../src/ImageManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2413 "ImageManager.c"
	}
}

static void
value_image_manager_init (GValue* value)
{
#line 26 "../src/ImageManager.vala"
	value->data[0].v_pointer = NULL;
#line 2422 "ImageManager.c"
}

static void
value_image_manager_free_value (GValue* value)
{
#line 26 "../src/ImageManager.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/ImageManager.vala"
		image_manager_unref (value->data[0].v_pointer);
#line 2432 "ImageManager.c"
	}
}

static void
value_image_manager_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 26 "../src/ImageManager.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = image_manager_ref (src_value->data[0].v_pointer);
#line 2444 "ImageManager.c"
	} else {
#line 26 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2448 "ImageManager.c"
	}
}

static gpointer
value_image_manager_peek_pointer (const GValue* value)
{
#line 26 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 2457 "ImageManager.c"
}

static gchar*
value_image_manager_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 26 "../src/ImageManager.vala"
	if (collect_values[0].v_pointer) {
#line 2468 "ImageManager.c"
		ImageManager * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/ImageManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/ImageManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2475 "ImageManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/ImageManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2479 "ImageManager.c"
		}
#line 26 "../src/ImageManager.vala"
		value->data[0].v_pointer = image_manager_ref (object);
#line 2483 "ImageManager.c"
	} else {
#line 26 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2487 "ImageManager.c"
	}
#line 26 "../src/ImageManager.vala"
	return NULL;
#line 2491 "ImageManager.c"
}

static gchar*
value_image_manager_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	ImageManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/ImageManager.vala"
	if (!object_p) {
#line 26 "../src/ImageManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2506 "ImageManager.c"
	}
#line 26 "../src/ImageManager.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/ImageManager.vala"
		*object_p = NULL;
#line 2512 "ImageManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/ImageManager.vala"
		*object_p = value->data[0].v_pointer;
#line 2516 "ImageManager.c"
	} else {
#line 26 "../src/ImageManager.vala"
		*object_p = image_manager_ref (value->data[0].v_pointer);
#line 2520 "ImageManager.c"
	}
#line 26 "../src/ImageManager.vala"
	return NULL;
#line 2524 "ImageManager.c"
}

GParamSpec*
param_spec_image_manager (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecImageManager* spec;
#line 26 "../src/ImageManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_IMAGE_MANAGER), NULL);
#line 26 "../src/ImageManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/ImageManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/ImageManager.vala"
	return G_PARAM_SPEC (spec);
#line 2543 "ImageManager.c"
}

gpointer
value_get_image_manager (const GValue* value)
{
#line 26 "../src/ImageManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_MANAGER), NULL);
#line 26 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 2553 "ImageManager.c"
}

void
value_set_image_manager (GValue* value,
                         gpointer v_object)
{
	ImageManager * old;
#line 26 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_MANAGER));
#line 26 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/ImageManager.vala"
	if (v_object) {
#line 26 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMAGE_MANAGER));
#line 26 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/ImageManager.vala"
		image_manager_ref (value->data[0].v_pointer);
#line 2575 "ImageManager.c"
	} else {
#line 26 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2579 "ImageManager.c"
	}
#line 26 "../src/ImageManager.vala"
	if (old) {
#line 26 "../src/ImageManager.vala"
		image_manager_unref (old);
#line 2585 "ImageManager.c"
	}
}

void
value_take_image_manager (GValue* value,
                          gpointer v_object)
{
	ImageManager * old;
#line 26 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_MANAGER));
#line 26 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/ImageManager.vala"
	if (v_object) {
#line 26 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMAGE_MANAGER));
#line 26 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 2606 "ImageManager.c"
	} else {
#line 26 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2610 "ImageManager.c"
	}
#line 26 "../src/ImageManager.vala"
	if (old) {
#line 26 "../src/ImageManager.vala"
		image_manager_unref (old);
#line 2616 "ImageManager.c"
	}
}

static void
image_manager_class_init (ImageManagerClass * klass,
                          gpointer klass_data)
{
#line 26 "../src/ImageManager.vala"
	image_manager_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/ImageManager.vala"
	((ImageManagerClass *) klass)->finalize = image_manager_finalize;
#line 26 "../src/ImageManager.vala"
	g_type_class_adjust_private_offset (klass, &ImageManager_private_offset);
#line 2630 "ImageManager.c"
}

static void
image_manager_instance_init (ImageManager * self,
                             gpointer klass)
{
#line 26 "../src/ImageManager.vala"
	self->priv = image_manager_get_instance_private (self);
#line 123 "../src/ImageManager.vala"
	self->priv->_available = TRUE;
#line 26 "../src/ImageManager.vala"
	self->ref_count = 1;
#line 2643 "ImageManager.c"
}

static void
image_manager_finalize (ImageManager * obj)
{
	ImageManager * self;
#line 26 "../src/ImageManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_MANAGER, ImageManager);
#line 26 "../src/ImageManager.vala"
	g_signal_handlers_destroy (self);
#line 122 "../src/ImageManager.vala"
	_g_array_unref0 (self->priv->_images);
#line 124 "../src/ImageManager.vala"
	_g_object_unref0 (self->priv->_id_map);
#line 2658 "ImageManager.c"
}

static GType
image_manager_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_image_manager_init, value_image_manager_free_value, value_image_manager_copy_value, value_image_manager_peek_pointer, "p", value_image_manager_collect_value, "p", value_image_manager_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ImageManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageManager), 0, (GInstanceInitFunc) image_manager_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType image_manager_type_id;
	image_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ImageManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ImageManager_private_offset = g_type_add_instance_private (image_manager_type_id, sizeof (ImageManagerPrivate));
	return image_manager_type_id;
}

GType
image_manager_get_type (void)
{
	static volatile gsize image_manager_type_id__once = 0;
	if (g_once_init_enter (&image_manager_type_id__once)) {
		GType image_manager_type_id;
		image_manager_type_id = image_manager_get_type_once ();
		g_once_init_leave (&image_manager_type_id__once, image_manager_type_id);
	}
	return image_manager_type_id__once;
}

gpointer
image_manager_ref (gpointer instance)
{
	ImageManager * self;
	self = instance;
#line 26 "../src/ImageManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/ImageManager.vala"
	return instance;
#line 2694 "ImageManager.c"
}

void
image_manager_unref (gpointer instance)
{
	ImageManager * self;
	self = instance;
#line 26 "../src/ImageManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/ImageManager.vala"
		IMAGE_MANAGER_GET_CLASS (self)->finalize (self);
#line 26 "../src/ImageManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2708 "ImageManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

