/* LinkType.c generated by valac 0.56.3, the Vala compiler
 * generated from LinkType.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_LINK_TYPE (link_type_get_type ())
#define LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINK_TYPE, LinkType))
#define IS_LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINK_TYPE))
#define LINK_TYPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LINK_TYPE, LinkTypeIface))

typedef struct _LinkType LinkType;
typedef struct _LinkTypeIface LinkTypeIface;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

struct _LinkTypeIface {
	GTypeInterface parent_iface;
	gchar* (*name) (LinkType* self);
	gchar* (*display_name) (LinkType* self);
	gchar* (*icon_name) (LinkType* self);
	void (*draw) (LinkType* self, cairo_t* ctx, Node* from_node, Node* to_node, gdouble from_x, gdouble from_y, gdouble to_x, gdouble to_y, gdouble* fx, gdouble* fy, gdouble* tx, gdouble* ty);
};

VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN GType link_type_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LinkType, g_object_unref)
VALA_EXTERN gchar* link_type_name (LinkType* self);
VALA_EXTERN gchar* link_type_display_name (LinkType* self);
VALA_EXTERN gchar* link_type_icon_name (LinkType* self);
VALA_EXTERN gpointer style_ref (gpointer instance);
VALA_EXTERN void style_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_style (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_style (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_style (const GValue* value);
VALA_EXTERN GType style_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Style, style_unref)
VALA_EXTERN gdouble link_type_adjust_a (LinkType* self,
                            Style* style);
VALA_EXTERN gboolean* style_get_link_arrow (Style* self);
VALA_EXTERN gint* style_get_link_width (Style* self);
VALA_EXTERN gint* style_get_node_borderwidth (Style* self);
VALA_EXTERN gdouble link_type_adjust_tip (LinkType* self,
                              Style* style);
VALA_EXTERN GType node_side_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gdouble link_type_adjust_mid_by (LinkType* self,
                                 Node* parent,
                                 NodeSide child_side);
VALA_EXTERN gboolean node_is_root (Node* self);
VALA_EXTERN gdouble node_get_width (Node* self);
VALA_EXTERN gdouble node_get_height (Node* self);
VALA_EXTERN void link_type_draw (LinkType* self,
                     cairo_t* ctx,
                     Node* from_node,
                     Node* to_node,
                     gdouble from_x,
                     gdouble from_y,
                     gdouble to_x,
                     gdouble to_y,
                     gdouble* fx,
                     gdouble* fy,
                     gdouble* tx,
                     gdouble* ty);
static GType link_type_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar*
link_type_name (LinkType* self)
{
	LinkTypeIface* _iface_;
#line 25 "../src/LinkType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/LinkType.vala"
	_iface_ = LINK_TYPE_GET_INTERFACE (self);
#line 25 "../src/LinkType.vala"
	if (_iface_->name) {
#line 25 "../src/LinkType.vala"
		return _iface_->name (self);
#line 151 "LinkType.c"
	}
#line 25 "../src/LinkType.vala"
	return NULL;
#line 155 "LinkType.c"
}

gchar*
link_type_display_name (LinkType* self)
{
	LinkTypeIface* _iface_;
#line 28 "../src/LinkType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/LinkType.vala"
	_iface_ = LINK_TYPE_GET_INTERFACE (self);
#line 28 "../src/LinkType.vala"
	if (_iface_->display_name) {
#line 28 "../src/LinkType.vala"
		return _iface_->display_name (self);
#line 170 "LinkType.c"
	}
#line 28 "../src/LinkType.vala"
	return NULL;
#line 174 "LinkType.c"
}

gchar*
link_type_icon_name (LinkType* self)
{
	LinkTypeIface* _iface_;
#line 31 "../src/LinkType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/LinkType.vala"
	_iface_ = LINK_TYPE_GET_INTERFACE (self);
#line 31 "../src/LinkType.vala"
	if (_iface_->icon_name) {
#line 31 "../src/LinkType.vala"
		return _iface_->icon_name (self);
#line 189 "LinkType.c"
	}
#line 31 "../src/LinkType.vala"
	return NULL;
#line 193 "LinkType.c"
}

gdouble
link_type_adjust_a (LinkType* self,
                    Style* style)
{
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gboolean* _tmp2_;
	gdouble result;
#line 33 "../src/LinkType.vala"
	g_return_val_if_fail (style != NULL, 0.0);
#line 34 "../src/LinkType.vala"
	_tmp1_ = style_get_link_arrow (style);
#line 34 "../src/LinkType.vala"
	_tmp2_ = _tmp1_;
#line 34 "../src/LinkType.vala"
	if (*_tmp2_) {
#line 212 "LinkType.c"
		gint* _tmp3_;
		gint* _tmp4_;
		gint* _tmp5_;
		gint* _tmp6_;
#line 34 "../src/LinkType.vala"
		_tmp3_ = style_get_link_width (style);
#line 34 "../src/LinkType.vala"
		_tmp4_ = _tmp3_;
#line 34 "../src/LinkType.vala"
		_tmp5_ = style_get_node_borderwidth (style);
#line 34 "../src/LinkType.vala"
		_tmp6_ = _tmp5_;
#line 34 "../src/LinkType.vala"
		_tmp0_ = ((*_tmp4_) / 2) + (((*_tmp6_) / 2) + 2);
#line 227 "LinkType.c"
	} else {
#line 34 "../src/LinkType.vala"
		_tmp0_ = 0;
#line 231 "LinkType.c"
	}
#line 34 "../src/LinkType.vala"
	result = (gdouble) _tmp0_;
#line 34 "../src/LinkType.vala"
	return result;
#line 237 "LinkType.c"
}

gdouble
link_type_adjust_tip (LinkType* self,
                      Style* style)
{
	gint* _tmp0_;
	gint* _tmp1_;
	gdouble result;
#line 37 "../src/LinkType.vala"
	g_return_val_if_fail (style != NULL, 0.0);
#line 38 "../src/LinkType.vala"
	_tmp0_ = style_get_link_width (style);
#line 38 "../src/LinkType.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/LinkType.vala"
	result = (gdouble) (((*_tmp1_) / 2) + 1);
#line 38 "../src/LinkType.vala"
	return result;
#line 257 "LinkType.c"
}

gdouble
link_type_adjust_mid_by (LinkType* self,
                         Node* parent,
                         NodeSide child_side)
{
	gdouble result;
#line 42 "../src/LinkType.vala"
	g_return_val_if_fail (parent != NULL, 0.0);
#line 43 "../src/LinkType.vala"
	if (node_is_root (parent)) {
#line 44 "../src/LinkType.vala"
		switch (child_side) {
#line 44 "../src/LinkType.vala"
			case NODE_SIDE_LEFT:
#line 274 "LinkType.c"
			{
				gdouble _tmp0_;
				gdouble _tmp1_;
#line 45 "../src/LinkType.vala"
				_tmp0_ = node_get_width (parent);
#line 45 "../src/LinkType.vala"
				_tmp1_ = _tmp0_;
#line 45 "../src/LinkType.vala"
				result = 0 - (_tmp1_ / 4);
#line 45 "../src/LinkType.vala"
				return result;
#line 286 "LinkType.c"
			}
#line 44 "../src/LinkType.vala"
			case NODE_SIDE_RIGHT:
#line 290 "LinkType.c"
			{
				gdouble _tmp2_;
				gdouble _tmp3_;
#line 46 "../src/LinkType.vala"
				_tmp2_ = node_get_width (parent);
#line 46 "../src/LinkType.vala"
				_tmp3_ = _tmp2_;
#line 46 "../src/LinkType.vala"
				result = _tmp3_ / 4;
#line 46 "../src/LinkType.vala"
				return result;
#line 302 "LinkType.c"
			}
#line 44 "../src/LinkType.vala"
			case NODE_SIDE_TOP:
#line 306 "LinkType.c"
			{
				gdouble _tmp4_;
				gdouble _tmp5_;
#line 47 "../src/LinkType.vala"
				_tmp4_ = node_get_height (parent);
#line 47 "../src/LinkType.vala"
				_tmp5_ = _tmp4_;
#line 47 "../src/LinkType.vala"
				result = 0 - (_tmp5_ / 4);
#line 47 "../src/LinkType.vala"
				return result;
#line 318 "LinkType.c"
			}
#line 44 "../src/LinkType.vala"
			case NODE_SIDE_BOTTOM:
#line 322 "LinkType.c"
			{
				gdouble _tmp6_;
				gdouble _tmp7_;
#line 48 "../src/LinkType.vala"
				_tmp6_ = node_get_height (parent);
#line 48 "../src/LinkType.vala"
				_tmp7_ = _tmp6_;
#line 48 "../src/LinkType.vala"
				result = _tmp7_ / 4;
#line 48 "../src/LinkType.vala"
				return result;
#line 334 "LinkType.c"
			}
			default:
#line 44 "../src/LinkType.vala"
			break;
#line 339 "LinkType.c"
		}
	}
#line 51 "../src/LinkType.vala"
	result = (gdouble) 0;
#line 51 "../src/LinkType.vala"
	return result;
#line 346 "LinkType.c"
}

void
link_type_draw (LinkType* self,
                cairo_t* ctx,
                Node* from_node,
                Node* to_node,
                gdouble from_x,
                gdouble from_y,
                gdouble to_x,
                gdouble to_y,
                gdouble* fx,
                gdouble* fy,
                gdouble* tx,
                gdouble* ty)
{
	LinkTypeIface* _iface_;
#line 55 "../src/LinkType.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/LinkType.vala"
	_iface_ = LINK_TYPE_GET_INTERFACE (self);
#line 55 "../src/LinkType.vala"
	if (_iface_->draw) {
#line 55 "../src/LinkType.vala"
		_iface_->draw (self, ctx, from_node, to_node, from_x, from_y, to_x, to_y, fx, fy, tx, ty);
#line 372 "LinkType.c"
	}
}

static void
link_type_default_init (LinkTypeIface * iface,
                        gpointer iface_data)
{
}

static GType
link_type_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LinkTypeIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) link_type_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType link_type_type_id;
	link_type_type_id = g_type_register_static (G_TYPE_INTERFACE, "LinkType", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (link_type_type_id, G_TYPE_OBJECT);
	return link_type_type_id;
}

GType
link_type_get_type (void)
{
	static volatile gsize link_type_type_id__once = 0;
	if (g_once_init_enter (&link_type_type_id__once)) {
		GType link_type_type_id;
		link_type_type_id = link_type_get_type_once ();
		g_once_init_leave (&link_type_type_id__once, link_type_type_id);
	}
	return link_type_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

