/* AnimatorAction.c generated by valac 0.56.3, the Vala compiler
 * generated from AnimatorAction.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	ANIMATION_TYPE_UNKNOWN = 0,
	ANIMATION_TYPE_NODES,
	ANIMATION_TYPE_NODE,
	ANIMATION_TYPE_PAN,
	ANIMATION_TYPE_SCALE,
	ANIMATION_TYPE_PANSCALE
} AnimationType;

#define TYPE_ANIMATION_TYPE (animation_type_get_type ())

#define TYPE_ANIMATOR_ACTION (animator_action_get_type ())
#define ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATOR_ACTION, AnimatorAction))
#define ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATOR_ACTION, AnimatorActionClass))
#define IS_ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATOR_ACTION))
#define IS_ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATOR_ACTION))
#define ANIMATOR_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATOR_ACTION, AnimatorActionClass))

typedef struct _AnimatorAction AnimatorAction;
typedef struct _AnimatorActionClass AnimatorActionClass;
typedef struct _AnimatorActionPrivate AnimatorActionPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
enum  {
	ANIMATOR_ACTION_0_PROPERTY,
	ANIMATOR_ACTION_INDEX_PROPERTY,
	ANIMATOR_ACTION_FRAMES_PROPERTY,
	ANIMATOR_ACTION_NUM_PROPERTIES
};
static GParamSpec* animator_action_properties[ANIMATOR_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AnimatorAction {
	GObject parent_instance;
	AnimatorActionPrivate * priv;
	gchar* _name;
	gint _id;
};

struct _AnimatorActionClass {
	GObjectClass parent_class;
	AnimationType (*type) (AnimatorAction* self);
	void (*capture) (AnimatorAction* self, DrawArea* da);
	void (*adjust) (AnimatorAction* self, DrawArea* da);
};

struct _AnimatorActionPrivate {
	gint _index;
	gdouble _frames;
};

static gint AnimatorAction_private_offset;
static gpointer animator_action_parent_class = NULL;
VALA_EXTERN gint animator_action__next_id;
gint animator_action__next_id = 0;

VALA_EXTERN GType animation_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType animator_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AnimatorAction, g_object_unref)
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN AnimationType animator_action_type (AnimatorAction* self);
VALA_EXTERN void animator_action_capture (AnimatorAction* self,
                              DrawArea* da);
VALA_EXTERN void animator_action_adjust (AnimatorAction* self,
                             DrawArea* da);
VALA_EXTERN AnimatorAction* animator_action_new (const gchar* name);
VALA_EXTERN AnimatorAction* animator_action_construct (GType object_type,
                                           const gchar* name);
VALA_EXTERN gchar* animator_action_name (AnimatorAction* self);
VALA_EXTERN gboolean animator_action_done (AnimatorAction* self);
VALA_EXTERN gint animator_action_get_index (AnimatorAction* self);
VALA_EXTERN gdouble animator_action_get_frames (AnimatorAction* self);
static AnimationType animator_action_real_type (AnimatorAction* self);
static void animator_action_real_capture (AnimatorAction* self,
                                   DrawArea* da);
static void animator_action_real_adjust (AnimatorAction* self,
                                  DrawArea* da);
VALA_EXTERN void animator_action_flush (AnimatorAction* self,
                            DrawArea* da);
static void animator_action_set_frames (AnimatorAction* self,
                                 gdouble value);
VALA_EXTERN void animator_action_set_index (AnimatorAction* self,
                                gint value);
static void animator_action_finalize (GObject * obj);
static GType animator_action_get_type_once (void);
static void _vala_animator_action_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_animator_action_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static GType
animation_type_get_type_once (void)
{
	static const GEnumValue values[] = {{ANIMATION_TYPE_UNKNOWN, "ANIMATION_TYPE_UNKNOWN", "unknown"}, {ANIMATION_TYPE_NODES, "ANIMATION_TYPE_NODES", "nodes"}, {ANIMATION_TYPE_NODE, "ANIMATION_TYPE_NODE", "node"}, {ANIMATION_TYPE_PAN, "ANIMATION_TYPE_PAN", "pan"}, {ANIMATION_TYPE_SCALE, "ANIMATION_TYPE_SCALE", "scale"}, {ANIMATION_TYPE_PANSCALE, "ANIMATION_TYPE_PANSCALE", "panscale"}, {0, NULL, NULL}};
	GType animation_type_type_id;
	animation_type_type_id = g_enum_register_static ("AnimationType", values);
	return animation_type_type_id;
}

GType
animation_type_get_type (void)
{
	static volatile gsize animation_type_type_id__once = 0;
	if (g_once_init_enter (&animation_type_type_id__once)) {
		GType animation_type_type_id;
		animation_type_type_id = animation_type_get_type_once ();
		g_once_init_leave (&animation_type_type_id__once, animation_type_type_id);
	}
	return animation_type_type_id__once;
}

static inline gpointer
animator_action_get_instance_private (AnimatorAction* self)
{
	return G_STRUCT_MEMBER_P (self, AnimatorAction_private_offset);
}

AnimatorAction*
animator_action_construct (GType object_type,
                           const gchar* name)
{
	AnimatorAction * self = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 47 "../src/animator/AnimatorAction.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 47 "../src/animator/AnimatorAction.vala"
	self = (AnimatorAction*) g_object_new (object_type, NULL);
#line 48 "../src/animator/AnimatorAction.vala"
	_tmp0_ = g_strdup (name);
#line 48 "../src/animator/AnimatorAction.vala"
	_g_free0 (self->_name);
#line 48 "../src/animator/AnimatorAction.vala"
	self->_name = _tmp0_;
#line 49 "../src/animator/AnimatorAction.vala"
	_tmp1_ = animator_action__next_id;
#line 49 "../src/animator/AnimatorAction.vala"
	animator_action__next_id = _tmp1_ + 1;
#line 49 "../src/animator/AnimatorAction.vala"
	self->_id = _tmp1_;
#line 47 "../src/animator/AnimatorAction.vala"
	return self;
#line 199 "AnimatorAction.c"
}

AnimatorAction*
animator_action_new (const gchar* name)
{
#line 47 "../src/animator/AnimatorAction.vala"
	return animator_action_construct (TYPE_ANIMATOR_ACTION, name);
#line 207 "AnimatorAction.c"
}

gchar*
animator_action_name (AnimatorAction* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 53 "../src/animator/AnimatorAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/animator/AnimatorAction.vala"
	_tmp0_ = self->_name;
#line 54 "../src/animator/AnimatorAction.vala"
	_tmp1_ = g_strconcat (_tmp0_, "-", NULL);
#line 54 "../src/animator/AnimatorAction.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/animator/AnimatorAction.vala"
	_tmp3_ = g_strdup_printf ("%i", self->_id);
#line 54 "../src/animator/AnimatorAction.vala"
	_tmp4_ = _tmp3_;
#line 54 "../src/animator/AnimatorAction.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 54 "../src/animator/AnimatorAction.vala"
	_tmp6_ = _tmp5_;
#line 54 "../src/animator/AnimatorAction.vala"
	_g_free0 (_tmp4_);
#line 54 "../src/animator/AnimatorAction.vala"
	_g_free0 (_tmp2_);
#line 54 "../src/animator/AnimatorAction.vala"
	result = _tmp6_;
#line 54 "../src/animator/AnimatorAction.vala"
	return result;
#line 245 "AnimatorAction.c"
}

gboolean
animator_action_done (AnimatorAction* self)
{
	gint _tmp0_;
	gdouble _tmp1_;
	gboolean result;
#line 58 "../src/animator/AnimatorAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../src/animator/AnimatorAction.vala"
	_tmp0_ = self->priv->_index;
#line 59 "../src/animator/AnimatorAction.vala"
	_tmp1_ = self->priv->_frames;
#line 59 "../src/animator/AnimatorAction.vala"
	result = ((gdouble) _tmp0_) > _tmp1_;
#line 59 "../src/animator/AnimatorAction.vala"
	return result;
#line 264 "AnimatorAction.c"
}

static AnimationType
animator_action_real_type (AnimatorAction* self)
{
	AnimationType result;
#line 64 "../src/animator/AnimatorAction.vala"
	result = ANIMATION_TYPE_UNKNOWN;
#line 64 "../src/animator/AnimatorAction.vala"
	return result;
#line 275 "AnimatorAction.c"
}

AnimationType
animator_action_type (AnimatorAction* self)
{
	AnimatorActionClass* _klass_;
#line 63 "../src/animator/AnimatorAction.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 63 "../src/animator/AnimatorAction.vala"
	_klass_ = ANIMATOR_ACTION_GET_CLASS (self);
#line 63 "../src/animator/AnimatorAction.vala"
	if (_klass_->type) {
#line 63 "../src/animator/AnimatorAction.vala"
		return _klass_->type (self);
#line 290 "AnimatorAction.c"
	}
#line 63 "../src/animator/AnimatorAction.vala"
	return 0;
#line 294 "AnimatorAction.c"
}

static void
animator_action_real_capture (AnimatorAction* self,
                              DrawArea* da)
{
#line 68 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (da != NULL);
#line 303 "AnimatorAction.c"
}

void
animator_action_capture (AnimatorAction* self,
                         DrawArea* da)
{
	AnimatorActionClass* _klass_;
#line 68 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/animator/AnimatorAction.vala"
	_klass_ = ANIMATOR_ACTION_GET_CLASS (self);
#line 68 "../src/animator/AnimatorAction.vala"
	if (_klass_->capture) {
#line 68 "../src/animator/AnimatorAction.vala"
		_klass_->capture (self, da);
#line 319 "AnimatorAction.c"
	}
}

static void
animator_action_real_adjust (AnimatorAction* self,
                             DrawArea* da)
{
#line 74 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (da != NULL);
#line 329 "AnimatorAction.c"
}

void
animator_action_adjust (AnimatorAction* self,
                        DrawArea* da)
{
	AnimatorActionClass* _klass_;
#line 74 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/animator/AnimatorAction.vala"
	_klass_ = ANIMATOR_ACTION_GET_CLASS (self);
#line 74 "../src/animator/AnimatorAction.vala"
	if (_klass_->adjust) {
#line 74 "../src/animator/AnimatorAction.vala"
		_klass_->adjust (self, da);
#line 345 "AnimatorAction.c"
	}
}

void
animator_action_flush (AnimatorAction* self,
                       DrawArea* da)
{
	gint _tmp0_;
#line 80 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (da != NULL);
#line 81 "../src/animator/AnimatorAction.vala"
	_tmp0_ = self->priv->_index;
#line 81 "../src/animator/AnimatorAction.vala"
	animator_action_set_frames (self, (gdouble) _tmp0_);
#line 82 "../src/animator/AnimatorAction.vala"
	animator_action_adjust (self, da);
#line 364 "AnimatorAction.c"
}

gint
animator_action_get_index (AnimatorAction* self)
{
	gint result;
#line 43 "../src/animator/AnimatorAction.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/animator/AnimatorAction.vala"
	result = self->priv->_index;
#line 43 "../src/animator/AnimatorAction.vala"
	return result;
#line 377 "AnimatorAction.c"
}

void
animator_action_set_index (AnimatorAction* self,
                           gint value)
{
	gint old_value;
#line 43 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/animator/AnimatorAction.vala"
	old_value = animator_action_get_index (self);
#line 43 "../src/animator/AnimatorAction.vala"
	if (old_value != value) {
#line 43 "../src/animator/AnimatorAction.vala"
		self->priv->_index = value;
#line 43 "../src/animator/AnimatorAction.vala"
		g_object_notify_by_pspec ((GObject *) self, animator_action_properties[ANIMATOR_ACTION_INDEX_PROPERTY]);
#line 395 "AnimatorAction.c"
	}
}

gdouble
animator_action_get_frames (AnimatorAction* self)
{
	gdouble result;
#line 44 "../src/animator/AnimatorAction.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 44 "../src/animator/AnimatorAction.vala"
	result = self->priv->_frames;
#line 44 "../src/animator/AnimatorAction.vala"
	return result;
#line 409 "AnimatorAction.c"
}

static void
animator_action_set_frames (AnimatorAction* self,
                            gdouble value)
{
	gdouble old_value;
#line 44 "../src/animator/AnimatorAction.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/animator/AnimatorAction.vala"
	old_value = animator_action_get_frames (self);
#line 44 "../src/animator/AnimatorAction.vala"
	if (old_value != value) {
#line 44 "../src/animator/AnimatorAction.vala"
		self->priv->_frames = value;
#line 44 "../src/animator/AnimatorAction.vala"
		g_object_notify_by_pspec ((GObject *) self, animator_action_properties[ANIMATOR_ACTION_FRAMES_PROPERTY]);
#line 427 "AnimatorAction.c"
	}
}

static void
animator_action_class_init (AnimatorActionClass * klass,
                            gpointer klass_data)
{
#line 37 "../src/animator/AnimatorAction.vala"
	animator_action_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/animator/AnimatorAction.vala"
	g_type_class_adjust_private_offset (klass, &AnimatorAction_private_offset);
#line 37 "../src/animator/AnimatorAction.vala"
	((AnimatorActionClass *) klass)->type = (AnimationType (*) (AnimatorAction*)) animator_action_real_type;
#line 37 "../src/animator/AnimatorAction.vala"
	((AnimatorActionClass *) klass)->capture = (void (*) (AnimatorAction*, DrawArea*)) animator_action_real_capture;
#line 37 "../src/animator/AnimatorAction.vala"
	((AnimatorActionClass *) klass)->adjust = (void (*) (AnimatorAction*, DrawArea*)) animator_action_real_adjust;
#line 37 "../src/animator/AnimatorAction.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_animator_action_get_property;
#line 37 "../src/animator/AnimatorAction.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_animator_action_set_property;
#line 37 "../src/animator/AnimatorAction.vala"
	G_OBJECT_CLASS (klass)->finalize = animator_action_finalize;
#line 37 "../src/animator/AnimatorAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANIMATOR_ACTION_INDEX_PROPERTY, animator_action_properties[ANIMATOR_ACTION_INDEX_PROPERTY] = g_param_spec_int ("index", "index", "index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 37 "../src/animator/AnimatorAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANIMATOR_ACTION_FRAMES_PROPERTY, animator_action_properties[ANIMATOR_ACTION_FRAMES_PROPERTY] = g_param_spec_double ("frames", "frames", "frames", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 10, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 455 "AnimatorAction.c"
}

static void
animator_action_instance_init (AnimatorAction * self,
                               gpointer klass)
{
#line 37 "../src/animator/AnimatorAction.vala"
	self->priv = animator_action_get_instance_private (self);
#line 43 "../src/animator/AnimatorAction.vala"
	self->priv->_index = 0;
#line 44 "../src/animator/AnimatorAction.vala"
	self->priv->_frames = (gdouble) 10;
#line 468 "AnimatorAction.c"
}

static void
animator_action_finalize (GObject * obj)
{
	AnimatorAction * self;
#line 37 "../src/animator/AnimatorAction.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANIMATOR_ACTION, AnimatorAction);
#line 39 "../src/animator/AnimatorAction.vala"
	_g_free0 (self->_name);
#line 37 "../src/animator/AnimatorAction.vala"
	G_OBJECT_CLASS (animator_action_parent_class)->finalize (obj);
#line 481 "AnimatorAction.c"
}

static GType
animator_action_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AnimatorActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) animator_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnimatorAction), 0, (GInstanceInitFunc) animator_action_instance_init, NULL };
	GType animator_action_type_id;
	animator_action_type_id = g_type_register_static (G_TYPE_OBJECT, "AnimatorAction", &g_define_type_info, 0);
	AnimatorAction_private_offset = g_type_add_instance_private (animator_action_type_id, sizeof (AnimatorActionPrivate));
	return animator_action_type_id;
}

GType
animator_action_get_type (void)
{
	static volatile gsize animator_action_type_id__once = 0;
	if (g_once_init_enter (&animator_action_type_id__once)) {
		GType animator_action_type_id;
		animator_action_type_id = animator_action_get_type_once ();
		g_once_init_leave (&animator_action_type_id__once, animator_action_type_id);
	}
	return animator_action_type_id__once;
}

static void
_vala_animator_action_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	AnimatorAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ANIMATOR_ACTION, AnimatorAction);
#line 37 "../src/animator/AnimatorAction.vala"
	switch (property_id) {
#line 37 "../src/animator/AnimatorAction.vala"
		case ANIMATOR_ACTION_INDEX_PROPERTY:
#line 37 "../src/animator/AnimatorAction.vala"
		g_value_set_int (value, animator_action_get_index (self));
#line 37 "../src/animator/AnimatorAction.vala"
		break;
#line 37 "../src/animator/AnimatorAction.vala"
		case ANIMATOR_ACTION_FRAMES_PROPERTY:
#line 37 "../src/animator/AnimatorAction.vala"
		g_value_set_double (value, animator_action_get_frames (self));
#line 37 "../src/animator/AnimatorAction.vala"
		break;
#line 528 "AnimatorAction.c"
		default:
#line 37 "../src/animator/AnimatorAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/animator/AnimatorAction.vala"
		break;
#line 534 "AnimatorAction.c"
	}
}

static void
_vala_animator_action_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	AnimatorAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ANIMATOR_ACTION, AnimatorAction);
#line 37 "../src/animator/AnimatorAction.vala"
	switch (property_id) {
#line 37 "../src/animator/AnimatorAction.vala"
		case ANIMATOR_ACTION_INDEX_PROPERTY:
#line 37 "../src/animator/AnimatorAction.vala"
		animator_action_set_index (self, g_value_get_int (value));
#line 37 "../src/animator/AnimatorAction.vala"
		break;
#line 37 "../src/animator/AnimatorAction.vala"
		case ANIMATOR_ACTION_FRAMES_PROPERTY:
#line 37 "../src/animator/AnimatorAction.vala"
		animator_action_set_frames (self, g_value_get_double (value));
#line 37 "../src/animator/AnimatorAction.vala"
		break;
#line 560 "AnimatorAction.c"
		default:
#line 37 "../src/animator/AnimatorAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/animator/AnimatorAction.vala"
		break;
#line 566 "AnimatorAction.c"
	}
}

